



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>图论$\cdot$最短路问题</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">图论$\cdot$最短路问题</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-25 15:59:31 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<ul><li>Dijkstra单源最短路径算法</li></ul>
<p>Dijkstra可以计算出发点到每个点的最短路，及单源最短路径（SSSP）。这一特点使得Dijkstra常常用来进行其他算法的预处理。用Dijkstra算法计算最短路的代码如下：</p>
<p>注：代码注释参见《算法竞赛入门经典&mdash;&mdash;训练指南》（刘汝佳）</p>
<div>
<pre class="prettyprint linenums"> struct Dijkstra{<br />
     int n, m;<br />
     vector&lt;E&gt; e;<br />
     vector&lt;int&gt; G[maxn];<br />
     bool done[maxn];<br />
     int d[maxn];<br />
     int p[maxn];<br />
     void init(int n){<br />
         this-&gt;n = n;<br />
         FOR(i, , n - ) G[i].clear();<br />
         e.clear();<br />
     }<br />
     void addE(int from, int to, int dist){<br />
         e.pb(E(from, to, dist));<br />
         m = e.size();<br />
         G[from].pb(m - );<br />
     }<br />
     void dijkstra(int s){<br />
         priority_queue&lt;HeapNode&gt; Q;<br />
         FOR(i, , n - ) d[i] = int_inf;<br />
         d[s] = ;<br />
         clr(done, );<br />
         Q.push(HeapNode(, s));<br />
         while(!Q.empty()){<br />
             HeapNode x = Q.top(); Q.pop();<br />
             int u = x.u;<br />
             if(done[u]) continue;<br />
             done[u] = ;<br />
             int sz = G[u].size();<br />
             FOR(i, , sz - ){<br />
                 E &amp;y = e[G[u][i]];<br />
                 if(d[y.to] &gt; d[u] + y.dist){<br />
                     d[y.to] = d[u] + y.dist;<br />
                     p[y.to] = G[u][i];<br />
                     Q.push(HeapNode(d[y.to], y.to));<br />
                 }<br />
             }<br />
         }<br />
     }<br />
 };</pre>
</div>
<ul><li>Bellman-Ford算法</li></ul>
<p>Bellman-Ford算法的一个重要应用是判负圈。在迭代$n-1$次后如果还可以进行松弛（relax）操作，说明一定存在负圈。如果采用队列实现，那么当某个结点入队了$n$次时可以判断出存在负圈，代码如下：</p>
<div>
<pre class="prettyprint linenums"> struct Bellman_Ford{<br />
     int n, m;<br />
     vector&lt;E&gt; e;<br />
     vector&lt;int&gt; G[maxn];<br />
     bool inq[maxn];<br />
     int d[maxn];<br />
     int p[maxn];<br />
     int cnt[maxn];<br />
     void init(int n){<br />
         this-&gt;n = n;<br />
         FOR(i, , n - ) G[i].clear();<br />
         e.clear();<br />
     }<br />
     void addE(int from, int to, int dist){<br />
         e.pb(E(from, to, dist));<br />
         m = e.size();<br />
         G[from].pb(m - );<br />
     }<br />
     bool negCyc(){<br />
         queue&lt;int&gt; Q;<br />
         clr(inq, ), clr(cnt, );<br />
         FOR(i, , n - ) d[i] = , inq[i] = , Q.push(i);<br />
         while(!Q.empty()){<br />
             int u = Q.front(); Q.pop();<br />
             inq[u] = ;<br />
             int sz = G[u].size();<br />
             FOR(i, , sz - ){<br />
                 E &amp;y = e[G[u][i]];<br />
                 if(d[y.to] &gt; d[u] + y.dist){<br />
                     d[y].to = d[u] + y.dist;<br />
                     p[e.to] = G[u][i];<br />
                     if(!inq[y.to]){<br />
                         Q.push(y.to);<br />
                         inq[y.to] = ;<br />
                         if(++cnt[y.to] &gt; n) return ;<br />
                     }<br />
                 }<br />
             }<br />
         }<br />
         return ;<br />
     }<br />
 };</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8zrem1q.html">SpringMVC之控制器的单例和多例管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq45zy39.html">001课-java&lowbar;web开发入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qymzmdq.html">jQuery EasyUI API 中文文档</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv1pxzq.html">c语言中函数的递归</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xvev09.html">The dialect was not set&period; Set the property hibernate&period;dialect</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x1yp09.html">Volatile总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w1k0lq.html">Python根据上下限生成不重复随机数1</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn7e108.html">Objective-C 协议&lpar;接口&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvgrgoq.html">php install</a>
		</li>
						<li><a href="https://www.batexi.com/a/950xe1z8.html">A Game of Thrones&lpar;8&rpar; - Bran</a>
		</li>
						<li><a href="https://www.batexi.com/a/950myye8.html">robotium从入门到放弃 一 测试开发环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyrz2x9.html">python学习笔记 list</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r50md4q.html">eclipse打Jar包问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll3d51q.html">Python查看关键字和帮助信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4ddwk9.html">一次对路边饮用水RFID供应机的跑路玩法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk313d8.html">27&period; Green Building 绿色建筑</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkl45v8.html">sqlalchemy外键关联</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnlle2q.html">zz 启动Matlab提示Microsoft Visual C&plus;&plus; 2005 Redistributable存在问题问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmrd7l9.html">ReentrantLock和synchronized的区别随笔</a>
		</li>
						<li><a href="https://www.batexi.com/a/9g3mr2zq.html">MVC之前的那点事儿 ---- 系列文章</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9p5py48.html">pt-table-checksum使用实践</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kzm238.html">已知一个日期和天数， 求多少天后的日期（是那个超时代码的AC版&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8ordep8.html">JS判断客户端系统 让ipad iphone 等手持设备自动跳到手机版</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8or3yx8.html">swt小知识点</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvw3ny9.html">k8s入门系列之集群安装篇</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j7drg9.html">mesos&plus;marathon&plus;zookeeper的docker管理集群亲手搭建实例&lpar;环境Centos6&period;8&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql0x70q.html">PythonDay02</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxgx2v9.html">RDIFramework&period;NET ━ &period;NET快速信息化系统开发框架 ━ 工作流程组件Web业务平台</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1x24z8.html">&lbrack;Android Tips&rsqb; 4&period; Dismiss PopupWindow when touch outside</a>
			</li>
						<li><a href="https://www.batexi.com/a/4951v0eq.html">Unity3D 装备系统学习Inventory Pro 2&period;1&period;2 总结</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
